"use strict";
/**
 * test logger
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var fourdollar_1 = require("../fourdollar");
var fs_extra_1 = require("fs-extra");
var path_1 = require("path");
var stop = require("stop.js");
describe('Logger', function () {
    describe('Logger', function () {
        var logger = new fourdollar_1.Logger('Hello');
        var origin = fourdollar_1.Logger.writer;
        var oriFormat = fourdollar_1.Logger.format;
        before(function () {
            fourdollar_1.Logger.writer = {
                log: null,
                error: null,
            };
        });
        after(function () {
            fourdollar_1.Logger.writer = origin;
            fourdollar_1.Logger.format = oriFormat;
        });
        it('Logger#log()', function (done) {
            fourdollar_1.Logger.writer.log = function (msg) {
                var reg = /\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}\.\d{3} > Hello - foo bar/;
                chai_1.expect(msg).to.match(reg);
                done();
            };
            logger.log('foo', 'bar');
        });
        it('Logger#error()', function (done) {
            fourdollar_1.Logger.writer.error = function (msg) {
                var reg = /\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}\.\d{3} > Hello - foo bar/;
                chai_1.expect(msg).to.match(reg);
                done();
            };
            logger.error('foo', 'bar');
        });
        it('Logger.format: default', function (done) {
            fourdollar_1.Logger.writer.log = function (msg) {
                chai_1.expect(msg).to.match(/\d{4}-\d\d-\d\d \d\d:\d\d:\d\d.\d{3} > Hello - foobar/);
                done();
            };
            logger.log('foobar');
        });
        it('Logger.format = ":time: > [:name:] :msg:"', function (done) {
            fourdollar_1.Logger.format = ':time: > [:name:] :msg:';
            fourdollar_1.Logger.writer.log = function (msg) {
                chai_1.expect(msg).to.match(/\d{4}-\d\d-\d\d \d\d:\d\d:\d\d.\d{3} > \[Hello\] foobar/);
                done();
            };
            logger.log('foobar');
        });
    });
    describe('FileWriter: normal stream', function () {
        var logger = new fourdollar_1.Logger('World');
        var dir = path_1.join(__dirname, 'log');
        var file = 'normal.log';
        before(function () {
            return fs_extra_1.remove(dir);
        });
        it('StreamLogger#log(): normal stream', function () { return __awaiter(_this, void 0, void 0, function () {
            var content, reg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fourdollar_1.Logger.writer.link = new fourdollar_1.FileWriter(path_1.join(dir, file));
                        logger.log('foobar');
                        return [4 /*yield*/, stop(500)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.readFile(path_1.join(dir, file))];
                    case 2:
                        content = _a.sent();
                        reg = /log: \d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}\.\d{3} > World - foobar/;
                        chai_1.expect(content).to.match(reg);
                        return [2 /*return*/];
                }
            });
        }); });
        it('StreamLogger#error(): normal stream', function () { return __awaiter(_this, void 0, void 0, function () {
            var content, reg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger.error('foobar');
                        return [4 /*yield*/, stop(500)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.readFile(path_1.join(dir, file))];
                    case 2:
                        content = _a.sent();
                        reg = /err: \d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}\.\d{3} > World - foobar/;
                        chai_1.expect(content.toString()).to.match(reg);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('FileWriter: rotating stream', function () {
        var logger = new fourdollar_1.Logger('World');
        var dir = path_1.join(__dirname, 'log');
        var file = 'rotating.log';
        it('StreamLogger#log(): rotating stream', function () { return __awaiter(_this, void 0, void 0, function () {
            var content, reg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fourdollar_1.Logger.writer = new fourdollar_1.FileWriter(path_1.join(dir, file), '1d');
                        logger.log('foobar');
                        return [4 /*yield*/, stop(500)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.readFile(path_1.join(dir, file))];
                    case 2:
                        content = _a.sent();
                        reg = /log: \d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}\.\d{3} > World - foobar/;
                        chai_1.expect(content).to.match(reg);
                        return [2 /*return*/];
                }
            });
        }); });
        it('StreamLogger#error(): rotating stream', function () { return __awaiter(_this, void 0, void 0, function () {
            var content, reg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger.error('foobar');
                        return [4 /*yield*/, stop(500)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, fs_extra_1.readFile(path_1.join(dir, file))];
                    case 2:
                        content = _a.sent();
                        reg = /err: \d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}\.\d{3} > World - foobar/;
                        chai_1.expect(content.toString()).to.match(reg);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('format', function () {
        var logger = new fourdollar_1.Logger('foobar');
        it('Logger.format default', function () {
        });
    });
});

//# sourceMappingURL=logger.spec.js.map
