"use strict";
/**
 * test number
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var fourdollar_1 = require("../fourdollar");
var timers_1 = require("timers");
describe('Timer', function () {
    it('Timer#start() && Timer#stop()', function (done) {
        var timer = new fourdollar_1.Timer(200, 100);
        var count = 0;
        timer.iterate(function () {
            count++;
            timer.stop();
        });
        // timer.start()
        timers_1.setTimeout(function () {
            chai_1.expect(count).to.equal(1);
            chai_1.expect(timer.isStarted).to.be.false;
            timer.start();
        }, 300);
        timers_1.setTimeout(function () {
            chai_1.expect(count).to.equal(2);
            chai_1.expect(timer.isStarted).to.be.false;
            done();
        }, 600);
    });
    it('Timer#iterate() && Timer#remove()', function (done) {
        var timer = new fourdollar_1.Timer(200, 100);
        var count = 0;
        var id01 = timer.iterate(function (val) {
            count += val;
        }, 3);
        var id02 = timer.iterate(function (val) {
            count += val;
        }, 7);
        var id03 = timer.iterate(function (val) {
            count += val;
        }, 11);
        var id04 = timer.iterate(function (val) {
            count += val;
            timer.stop();
            chai_1.expect(count).to.equal(27);
            done();
        }, 13);
        // timer.start()
        timer.remove(id02);
    });
    it('Timer > 0.2초에 한번씩 실행 된다.', function (done) {
        var timer = new fourdollar_1.Timer(200);
        var count = 0;
        timer.iterate(function (sDate) {
            var t = new Date().getTime() - sDate.getTime();
            chai_1.expect(Math.floor(t / 100)).to.equal(2 * ++count);
            if (count === 3) {
                timer.stop();
                done();
            }
        }, new Date());
        // timer.start()
    });
    it('Timer > 0.5초에 모든 work들이 한번씩 실행 된다.', function (done) {
        var timer = new fourdollar_1.Timer(500);
        timer.iterate(function (sDate) {
            var t = (new Date().getTime() - sDate.getTime());
            chai_1.expect(Math.floor(t / 100)).to.equal(1);
        }, new Date());
        timer.iterate(function (sDate) {
            var t = (new Date().getTime() - sDate.getTime());
            chai_1.expect(Math.floor(t / 100)).to.equal(2);
        }, new Date());
        timer.iterate(function (sDate) {
            var t = (new Date().getTime() - sDate.getTime());
            chai_1.expect(Math.floor(t / 100)).to.equal(3);
        }, new Date());
        timer.iterate(function (sDate) {
            var t = (new Date().getTime() - sDate.getTime());
            chai_1.expect(Math.floor(t / 100)).to.equal(4);
        }, new Date());
        timer.iterate(function (sDate) {
            var t = (new Date().getTime() - sDate.getTime());
            chai_1.expect(Math.floor(t / 100)).to.equal(5);
            timer.stop();
            done();
        }, new Date());
        // timer.start()
    });
    it('Timer > minTick', function (done) {
        var timer = new fourdollar_1.Timer(200, 100);
        timer.iterate(function (sDate) {
            var t = new Date().getTime() - sDate.getTime();
            chai_1.expect(Math.floor(t / 100)).to.equal(1);
        }, new Date());
        timer.iterate(function (sDate) {
            var t = new Date().getTime() - sDate.getTime();
            chai_1.expect(Math.floor(t / 100)).to.equal(2);
        }, new Date());
        timer.iterate(function (sDate) {
            var t = new Date().getTime() - sDate.getTime();
            chai_1.expect(Math.floor(t / 100)).to.equal(3);
        }, new Date());
        timer.iterate(function (sDate) {
            var t = new Date().getTime() - sDate.getTime();
            chai_1.expect(Math.floor(t / 100)).to.equal(4);
            timer.stop();
            done();
        }, new Date());
        // timer.start()
    });
    it('Timer#once()', function () { return __awaiter(_this, void 0, void 0, function () {
        function work(echo) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, echo];
                });
            });
        }
        var timer, echo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    timer = new fourdollar_1.Timer(100);
                    return [4 /*yield*/, timer.once(work, 'hello')];
                case 1:
                    echo = _a.sent();
                    chai_1.expect(echo).to.equal('hello');
                    timer.stop();
                    return [2 /*return*/];
            }
        });
    }); });
    it('Timer#once() > 0.2초후 실행된다.', function () { return __awaiter(_this, void 0, void 0, function () {
        function work() {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, new Date().getTime()];
                });
            });
        }
        var timer, sTime, eTime;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    timer = new fourdollar_1.Timer(200, 100);
                    sTime = new Date().getTime();
                    return [4 /*yield*/, timer.once(work)];
                case 1:
                    eTime = _a.sent();
                    chai_1.expect(Math.floor((eTime - sTime) / 100)).to.equal(2);
                    return [2 /*return*/];
            }
        });
    }); });
    it('Timer#once() > once()와 iterate()가 벌갈아 실행된다.', function () { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        function work() {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, new Date().getTime()];
                });
            });
        }
        var sTime, timer, eTime;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sTime = new Date().getTime();
                    timer = new fourdollar_1.Timer(200, 100);
                    timer.iterate(function () {
                        var eTime = new Date().getTime();
                        chai_1.expect(Math.floor((eTime - sTime) / 100)).to.equal(1);
                    });
                    timer.iterate(function () {
                        var eTime = new Date().getTime();
                        chai_1.expect(Math.floor((eTime - sTime) / 100)).to.equal(3);
                    });
                    return [4 /*yield*/, timer.once(function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, new Date().getTime()];
                            });
                        }); })];
                case 1:
                    eTime = _a.sent();
                    chai_1.expect(Math.floor((eTime - sTime) / 100)).to.equal(2);
                    return [4 /*yield*/, timer.once(function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, new Date().getTime()];
                            });
                        }); })];
                case 2:
                    eTime = _a.sent();
                    chai_1.expect(Math.floor((eTime - sTime) / 100)).to.equal(4);
                    timer.stop();
                    return [2 /*return*/];
            }
        });
    }); });
});

//# sourceMappingURL=timer.spec.js.map
