"use strict";
/**
 * test url
 */
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var fourdollar_1 = require("../fourdollar");
describe('Url', function () {
    describe('toStringQuery()', function () {
        it('query가 없을때 ""을 반환한다.', function () {
            chai_1.expect(fourdollar_1.toStringQuery({})).to.equal('');
            chai_1.expect(fourdollar_1.toStringQuery('')).to.equal('');
        });
        it('query가 하나일때 올바르게 반환한다.', function () {
            var result = fourdollar_1.toStringQuery({ hello: 'world' });
            chai_1.expect(result).to.equal('hello=world');
        });
        it('query가 하나 이상일때 올바르게 반환한다.', function () {
            var result = fourdollar_1.toStringQuery({ hello: 'world', foo: 'bar' });
            chai_1.expect(result).to.equal('hello=world&foo=bar');
        });
    });
});

//# sourceMappingURL=url.spec.js.map
